#line 1 "D:/public/emeter/libADC.c"
#line 1 "d:/public/emeter/libadc.h"
#line 13 "d:/public/emeter/libadc.h"
void ADC_Init(unsigned int Achannles, unsigned int Afs, void (*TADCIRQCallback) (unsigned int ANumOfSamples, unsigned int *ASamples[16]));
void ADC_StartSample();
void ADC_Disable();
void ADC_Enable();
#line 11 "D:/public/emeter/libADC.c"
unsigned int FSampleBuffer[16];
unsigned int FChannelCount;
void (*FADCIRQCallback) (unsigned int ANumOfSamples, unsigned int *ASamples[16]);


void ADC_InterruptSampleReady(void) org 0x2E {

int i;
unsigned int *ADC16Ptr;

 ADC16Ptr = &ADC1BUF0;

 for ( i = 0; i < FChannelCount; i++ ) {
 FSampleBuffer[i] = *ADC16Ptr;
 ADC16Ptr++;
 }

 FADCIRQCallback(FChannelCount, &FSampleBuffer);


 IFS0.B13 = 0;

}


void ADC_Enable(void) {


 IFS0.B13 = 0;


 IEC0.B13 = 1;

}


void ADC_Disable(void) {


 IEC0.B13 = 0;


 IFS0.B13 = 0;

}


void ADC_StartSample(void) {

 AD1CON1.B2 = 1;
}


void ADC_Init(unsigned int Achannels,unsigned int Afs, void (*TADCIRQCallback) (unsigned int ANumOfSamples, unsigned int *ASamples[16])) {

 unsigned int i;
 char txt[200];

 unsigned long calcInterval1;
 unsigned int T3PreScale;



 FADCIRQCallback = TADCIRQCallback;


 FChannelCount = 0;

 for ( i = 0; i < 16; i++ ) {
 if (((unsigned int)Achannels & (unsigned int)(1 << i)) > 0) {
 FChannelCount++;
 }
 }


 AD1PCFG = (unsigned int)~((unsigned int)Achannels);


 AD1CON1 = 0x0040;


 AD1CHS = 0x0000;


 AD1CSSL = Achannels;




 AD1CON3 = 0x1F0F;





 AD1CON2 = 0x0400 | ((FChannelCount - 1) << 2);


 calcInterval1 = Clock_kHz() / 2;
 calcInterval1 = (calcInterval1 * 1000) / Afs;
 calcInterval1 = calcInterval1 / FChannelCount;

 T3PreScale = 0;
 if (calcInterval1 > 65535) {
 T3PreScale = 1;
 calcInterval1 = calcInterval1 / 8;
 }

 if (calcInterval1 > 65535) {
 T3PreScale = 2;
 calcInterval1 = calcInterval1 / 8;
 }

 if (calcInterval1 > 65535) {
 T3PreScale = 3;
 calcInterval1 = calcInterval1 / 4;
 }


 T3CON = 0x8000 | (T3PreScale << 4);
 PR3 = calcInterval1;

 AD1CON1.B15 = 1;
}
