
_ADC_InterruptSampleReady:
	PUSH	RCOUNT
	PUSH	W0
	MOV	#2, W0
	REPEAT	#12
	PUSH	[W0++]

;libADC.c,16 :: 		void ADC_InterruptSampleReady(void) org 0x2E {
;libADC.c,21 :: 		ADC16Ptr = &ADC1BUF0;                     // Initialize ADC1BUF pointer
	PUSH	W10
	PUSH	W11
; ADC16Ptr start address is: 6 (W3)
	MOV	#lo_addr(ADC1BUF0), W3
;libADC.c,23 :: 		for ( i = 0; i < FChannelCount; i++ ) {
; i start address is: 4 (W2)
	CLR	W2
; ADC16Ptr end address is: 6 (W3)
; i end address is: 4 (W2)
L_ADC_InterruptSampleReady0:
; i start address is: 4 (W2)
; ADC16Ptr start address is: 6 (W3)
	MOV	#lo_addr(_FChannelCount), W0
	CP	W2, [W0]
	BRA LTU	L__ADC_InterruptSampleReady14
	GOTO	L_ADC_InterruptSampleReady1
L__ADC_InterruptSampleReady14:
;libADC.c,24 :: 		FSampleBuffer[i] = *ADC16Ptr;         // Insert sample into buffer
	SL	W2, #1, W1
	MOV	#lo_addr(_FSampleBuffer), W0
	ADD	W0, W1, W0
	MOV	[W3], [W0]
;libADC.c,25 :: 		ADC16Ptr++;                           // Next sample
	INC2	W3
;libADC.c,23 :: 		for ( i = 0; i < FChannelCount; i++ ) {
	INC	W2
;libADC.c,26 :: 		}
; ADC16Ptr end address is: 6 (W3)
; i end address is: 4 (W2)
	GOTO	L_ADC_InterruptSampleReady0
L_ADC_InterruptSampleReady1:
;libADC.c,28 :: 		FADCIRQCallback(FChannelCount, &FSampleBuffer);
	MOV	#lo_addr(_FSampleBuffer), W11
	MOV	_FChannelCount, W10
	MOV	_FADCIRQCallback, W0
	CALL	W0
;libADC.c,31 :: 		IFS0.B13 = 0;
	BCLR	IFS0, #13
;libADC.c,33 :: 		}
L_end_ADC_InterruptSampleReady:
	POP	W11
	POP	W10
	MOV	#26, W0
	REPEAT	#12
	POP	[W0--]
	POP	W0
	POP	RCOUNT
	RETFIE
; end of _ADC_InterruptSampleReady

_ADC_Enable:

;libADC.c,36 :: 		void ADC_Enable(void) {
;libADC.c,39 :: 		IFS0.B13 = 0;
	BCLR	IFS0, #13
;libADC.c,42 :: 		IEC0.B13 = 1;
	BSET	IEC0, #13
;libADC.c,44 :: 		}
L_end_ADC_Enable:
	RETURN
; end of _ADC_Enable

_ADC_Disable:

;libADC.c,47 :: 		void ADC_Disable(void) {
;libADC.c,50 :: 		IEC0.B13 = 0;
	BCLR	IEC0, #13
;libADC.c,53 :: 		IFS0.B13 = 0;
	BCLR	IFS0, #13
;libADC.c,55 :: 		}
L_end_ADC_Disable:
	RETURN
; end of _ADC_Disable

_ADC_StartSample:

;libADC.c,58 :: 		void ADC_StartSample(void) {
;libADC.c,60 :: 		AD1CON1.B2 = 1;                       // auto start sampling for 31Tad
	BSET	AD1CON1, #2
;libADC.c,61 :: 		}
L_end_ADC_StartSample:
	RETURN
; end of _ADC_StartSample

_ADC_Init:

;libADC.c,64 :: 		void ADC_Init(unsigned int Achannels,unsigned  int Afs, void (*TADCIRQCallback) (unsigned int ANumOfSamples, unsigned int *ASamples[16])) {
;libADC.c,74 :: 		FADCIRQCallback = TADCIRQCallback;
	MOV	W12, _FADCIRQCallback
;libADC.c,77 :: 		FChannelCount = 0;
	CLR	W0
	MOV	W0, _FChannelCount
;libADC.c,79 :: 		for ( i = 0; i < 16; i++ ) {
; i start address is: 4 (W2)
	CLR	W2
; i end address is: 4 (W2)
L_ADC_Init3:
; i start address is: 4 (W2)
	CP	W2, #16
	BRA LTU	L__ADC_Init19
	GOTO	L_ADC_Init4
L__ADC_Init19:
;libADC.c,80 :: 		if (((unsigned int)Achannels & (unsigned int)(1 << i)) > 0) {
	MOV	#1, W0
	SL	W0, W2, W0
	AND	W10, W0, W0
	CP	W0, #0
	BRA GTU	L__ADC_Init20
	GOTO	L_ADC_Init6
L__ADC_Init20:
;libADC.c,81 :: 		FChannelCount++;
	MOV	#1, W1
	MOV	#lo_addr(_FChannelCount), W0
	ADD	W1, [W0], [W0]
;libADC.c,82 :: 		}
L_ADC_Init6:
;libADC.c,79 :: 		for ( i = 0; i < 16; i++ ) {
	INC	W2
;libADC.c,83 :: 		}
; i end address is: 4 (W2)
	GOTO	L_ADC_Init3
L_ADC_Init4:
;libADC.c,86 :: 		AD1PCFG = (unsigned int)~((unsigned int)Achannels);
	MOV	#lo_addr(AD1PCFG), W1
	MOV	W10, W0
	COM	W0, [W1]
;libADC.c,89 :: 		AD1CON1 = 0x0040;
	MOV	#64, W0
	MOV	WREG, AD1CON1
;libADC.c,92 :: 		AD1CHS = 0x0000;
	CLR	AD1CHS
;libADC.c,95 :: 		AD1CSSL = Achannels;
	MOV	W10, AD1CSSL
;libADC.c,100 :: 		AD1CON3 = 0x1F0F;
	MOV	#7951, W0
	MOV	WREG, AD1CON3
;libADC.c,106 :: 		AD1CON2 = 0x0400 | ((FChannelCount - 1) << 2);
	MOV	_FChannelCount, W0
	DEC	W0
	SL	W0, #2, W2
	MOV	#1024, W1
	MOV	#lo_addr(AD1CON2), W0
	IOR	W1, W2, [W0]
;libADC.c,110 :: 		calcInterval1 = (calcInterval1 * 1000) / Afs;
	PUSH	W12
	PUSH.D	W10
	MOV	W11, W2
	CLR	W3
	MOV	#11520, W0
	MOV	#305, W1
	CLR	W4
	CALL	__Divide_32x32
;libADC.c,111 :: 		calcInterval1 = calcInterval1 / FChannelCount;
	MOV	_FChannelCount, W2
	CLR	W3
	CLR	W4
	CALL	__Divide_32x32
	POP.D	W10
	POP	W12
; calcInterval1 start address is: 8 (W4)
	MOV.D	W0, W4
;libADC.c,113 :: 		T3PreScale = 0;
; T3PreScale start address is: 12 (W6)
	CLR	W6
;libADC.c,114 :: 		if (calcInterval1 > 65535) {
	MOV	#65535, W2
	MOV	#0, W3
	CP	W0, W2
	CPB	W1, W3
	BRA GTU	L__ADC_Init21
	GOTO	L__ADC_Init10
L__ADC_Init21:
; T3PreScale end address is: 12 (W6)
;libADC.c,115 :: 		T3PreScale = 1;
; T3PreScale start address is: 2 (W1)
	MOV	#1, W1
;libADC.c,116 :: 		calcInterval1 = calcInterval1 / 8;
	MOV	#3, W0
; calcInterval1 start address is: 4 (W2)
	MOV.D	W4, W2
L__ADC_Init22:
	DEC	W0, W0
	BRA LT	L__ADC_Init23
	LSR	W3, W3
	RRC	W2, W2
	BRA	L__ADC_Init22
L__ADC_Init23:
; calcInterval1 end address is: 8 (W4)
	MOV	W1, W4
; T3PreScale end address is: 2 (W1)
; calcInterval1 end address is: 4 (W2)
;libADC.c,117 :: 		}
	GOTO	L_ADC_Init7
L__ADC_Init10:
;libADC.c,114 :: 		if (calcInterval1 > 65535) {
	MOV.D	W4, W2
	MOV	W6, W4
;libADC.c,117 :: 		}
L_ADC_Init7:
;libADC.c,119 :: 		if (calcInterval1 > 65535) {
; calcInterval1 start address is: 4 (W2)
; T3PreScale start address is: 8 (W4)
	MOV	#65535, W0
	MOV	#0, W1
	CP	W2, W0
	CPB	W3, W1
	BRA GTU	L__ADC_Init24
	GOTO	L__ADC_Init11
L__ADC_Init24:
; T3PreScale end address is: 8 (W4)
;libADC.c,120 :: 		T3PreScale = 2;
; T3PreScale start address is: 2 (W1)
	MOV	#2, W1
;libADC.c,121 :: 		calcInterval1 = calcInterval1 / 8;
	MOV	#3, W0
L__ADC_Init25:
	DEC	W0, W0
	BRA LT	L__ADC_Init26
	LSR	W3, W3
	RRC	W2, W2
	BRA	L__ADC_Init25
L__ADC_Init26:
	MOV	W1, W4
; T3PreScale end address is: 2 (W1)
; calcInterval1 end address is: 4 (W2)
;libADC.c,122 :: 		}
	GOTO	L_ADC_Init8
L__ADC_Init11:
;libADC.c,119 :: 		if (calcInterval1 > 65535) {
;libADC.c,122 :: 		}
L_ADC_Init8:
;libADC.c,124 :: 		if (calcInterval1 > 65535) {
; calcInterval1 start address is: 4 (W2)
; T3PreScale start address is: 8 (W4)
	MOV	#65535, W0
	MOV	#0, W1
	CP	W2, W0
	CPB	W3, W1
	BRA GTU	L__ADC_Init27
	GOTO	L__ADC_Init12
L__ADC_Init27:
; T3PreScale end address is: 8 (W4)
;libADC.c,125 :: 		T3PreScale = 3;
; T3PreScale start address is: 0 (W0)
	MOV	#3, W0
;libADC.c,126 :: 		calcInterval1 = calcInterval1 / 4;
; calcInterval1 start address is: 6 (W3)
	MOV	W3, W4
	MOV	W2, W3
; calcInterval1 end address is: 4 (W2)
	LSR	W4, W4
	RRC	W3, W3
	LSR	W4, W4
	RRC	W3, W3
; calcInterval1 end address is: 6 (W3)
; T3PreScale end address is: 0 (W0)
;libADC.c,127 :: 		}
	GOTO	L_ADC_Init9
L__ADC_Init12:
;libADC.c,124 :: 		if (calcInterval1 > 65535) {
	MOV	W4, W0
	MOV	W3, W4
	MOV	W2, W3
;libADC.c,127 :: 		}
L_ADC_Init9:
;libADC.c,130 :: 		T3CON = 0x8000 | (T3PreScale << 4);
; calcInterval1 start address is: 6 (W3)
; T3PreScale start address is: 0 (W0)
	SL	W0, #4, W2
; T3PreScale end address is: 0 (W0)
	MOV	#32768, W1
	MOV	#lo_addr(T3CON), W0
	IOR	W1, W2, [W0]
;libADC.c,131 :: 		PR3 = calcInterval1;
	MOV	W3, PR3
; calcInterval1 end address is: 6 (W3)
;libADC.c,133 :: 		AD1CON1.B15 = 1;
	BSET	AD1CON1, #15
;libADC.c,134 :: 		}
L_end_ADC_Init:
	RETURN
; end of _ADC_Init
